<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_certification".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderCertification".
 *
 * Columns in table "provider_certification" available as properties of the model,
 * followed by relations of table "provider_certification" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $certifying_body_id
 * @property integer $certification_type_id
 * @property integer $certification_specialty_id
 * @property integer $certification_sub_specialty_id
 * @property integer $year_achieved
 *
 * @property CertificationType $certificationType
 * @property CertifyingBody $certifyingBody
 * @property Provider $provider
 * @property SubSpecialty $subSpecialty
 */
abstract class BaseProviderCertification extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_certification';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('provider_id, certifying_body_id, certification_type_id', 'required'),
            array('provider_id, certifying_body_id, certification_type_id, certification_specialty_id, '
                . 'certification_sub_specialty_id, year_achieved', 'numerical', 'integerOnly' => true),
            array('year_achieved, certification_sub_specialty_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, certifying_body_id, certification_type_id, certification_specialty_id, '
                . 'certification_sub_specialty_id, year_achieved', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'certificationType' => array(self::BELONGS_TO, 'CertificationType', 'certification_type_id'),
            'certifyingBody' => array(self::BELONGS_TO, 'CertifyingBody', 'certifying_body_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'certificationSpecialty' => array(self::BELONGS_TO, 'CertificationSpecialty', 'certification_specialty_id'),
            'certificationSubSpecialty' => array(self::BELONGS_TO, 'CertificationSubSpecialty',
                'certification_sub_specialty_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'certifying_body_id' => Yii::t('app', 'Certifying Body'),
            'certification_type_id' => Yii::t('app', 'Certification Type'),
            'certification_specialty_id' => Yii::t('app', 'Specialty'),
            'certification_sub_specialty_id' => Yii::t('app', 'Sub-Specialty (if any)'),
            'year_achieved' => Yii::t('app', 'Year Achieved'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        //this is to enable eager loading - looks like it's no good to add provider to the eager list
        $criteria->with = array(
            'certifyingBody',
            'certificationType',
            'certificationSpecialty',
            'certificationSubSpecialty'
        );

        //$criteria->compare('id', $this->id);
        //$criteria->compare('provider_id', $this->provider_id);
        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else {
            $criteria->compare('provider_id', $this->provider_id);
        }
        $criteria->compare('t.certifying_body_id', $this->certifying_body_id);
        $criteria->compare('certification_type_id', $this->certification_type_id);
        $criteria->compare('certification_specialty_id', $this->certification_specialty_id);
        $criteria->compare('certification_sub_specialty_id', $this->certification_sub_specialty_id);
        $criteria->compare('year_achieved', $this->year_achieved);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderCertification|ProviderCertification', $n);
    }

}
